def insert(t, e):
    if t is None:
        return [e, None, None]
    if e < t[0]:
        t[1] = insert(t[1], e)
    else:
        t[2] = insert(t[2], e)
    return t


def as_string(t):
    if t is None:
        return ""
    return as_string(t[1])+" "+str(t[0])+", "+as_string(t[2])


# could be str(tree_as_list(t))
def tree_as_string(t):
    return "[" + as_string(t) + "]"


def is_in(t, e):
    if t is None:
        return False
    if t[0] == e:
        return True
    if e < t[0]:
        return is_in(t[1], e)
    else:
        return is_in(t[2], e)


def max(t):
    if t is None:
        return None
    if t[2] is None:
        return t[0]
    return max(t[2])


def min(t):
    if t is None:
        return None
    if t[1] is None:
        return t[0]
    return min(t[1])


def tree_as_list(t):
    if t is None:
        return []
    return tree_as_list(t[1])+[t[0]]+tree_as_list(t[2])


def list_as_tree(l):
    root = None
    for e in l:
        root = insert(root, e)
    return root


def minimum_original(t, p):
    while t[1] is not None:
        p = t
        t = t[1]
    return t, p


def minimum(t):
    while t[1] is not None:
        t = t[1]
    return t


def delete(t, e):
    if t is None:
        return None
    if e == t[0]:
        if t[1] is None and t[2] is None:
            return None
        if t[1] is not None and t[2] is None:
            left = t[1]
            t[0], t[1], t[2] = left[0], left[1], left[2]
            return t
        if t[1] is None and t[2] is not None:
            right = t[2]
            t[0], t[1], t[2] = right[0], right[1], right[2]
            return t
        mini, p = minimum_original(t[2], t)
        t[0] = mini[0]
        if p == t:
            t[2] = delete(mini, mini[0])
        else:
            p[1] = delete(mini, mini[0])
        return t
    if e < t[0]:
        t[1] = delete(t[1], e)
    else:
        t[2] = delete(t[2], e)
    return t


def delete_original(t, e, parent=None):
    if t is None:
        return None
    if e == t[0]:
        if t[1] is None and t[2] is None:
            return None
        if t[1] is not None and t[2] is None:
            left = t[1]
            t[0], t[1], t[2] = left[0], left[1], left[2]
            return t
        if t[1] is None and t[2] is not None:
            right = t[2]
            t[0], t[1], t[2] = right[0], right[1], right[2]
            return t
        mini, p = minimum_original(t[2], parent)
        t[0] = mini[0]
        delete(mini, mini[0], p)
        return t
    if e < t[0]:
        t[1] = delete_original(t[1], e, t)
    else:
        t[2] = delete_original(t[2], e, t)
    return t
